



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[转]编写高性能的Lua代码</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[转]编写高性能的Lua代码</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 09:11:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>昨天晚上闲来无事，看室友在电脑上挂机玩游戏，用的一个辅助脚本，以为是lua写的脚本在跑，实际调查发现是按键精灵的脚本。</p>
<p>于是在网上找相关Lua开发游戏脚本的案例，看到一个人的博客，内容很不错，学到了很多很多，特别是性能方面的，一直没有对Lua的数据结构了解。</p>
<p>Lua最大的特点之一就是性能，当然，如果在编码方面写的好会提升更大的性能问题。</p>
<p>一下是作者中的文章内容，拿来也给大家学习和参考：</p>
<hr />
<h2>前言</h2>
<p>Lua是一门以其性能著称的脚本语言，被广泛应用在很多方面，尤其是游戏。像《魔兽世界》的插件，手机游戏《大掌门》《神曲》《迷失之地》等都是用Lua来写的逻辑。</p>
<p>所以大部分时候我们不需要去考虑性能问题。Knuth有句名言：&ldquo;过早优化是万恶之源&rdquo;。其意思就是过早优化是不必要的，会浪费大量时间，而且容易导致代码混乱。</p>
<p>所以一个好的程序员在考虑优化性能前必须问自己两个问题：&ldquo;我的程序真的需要优化吗？&rdquo;。如果答案为是，那么再问自己：&ldquo;优化哪个部分？&rdquo;。</p>
<p>我们不能靠臆想和凭空猜测来决定优化哪个部分，代码的运行效率必须是可测量的。我们需要借助于分析器来测定性能的瓶颈，然后着手优化。优化后，我们仍然要借助于分析器来测量所做的优化是否真的有效。</p>
<p>我认为最好的方式是在首次编写的时候按照最佳实践去写出高性能的代码，而不是编写了一堆垃圾代码后，再考虑优化。相信工作后大家都会对事后的优化的繁琐都深有体会。</p>
<p>一旦你决定编写高性能的Lua代码，下文将会指出在Lua中哪些代码是可以优化的，哪些代码会是运行缓慢的，然后怎么去优化它们。</p>
<h2>使用local</h2>
<p>在代码运行前，Lua会把源码预编译成一种中间码，类似于Java的虚拟机。这种格式然后会通过C的解释器进行解释，整个过程其实就是通过一个&nbsp;while&nbsp;循环，里面有很多的&nbsp;switch...case&nbsp;语句，一个&nbsp;case&nbsp;；对应一条指令来解析。</p>
<p>自Lua 5.0之后，Lua采用了一种类似于寄存器的虚拟机模式。Lua用栈来储存其寄存器。每一个活动的函数，Lua都会其分配一个栈，这个栈用来储存函数里的活动记录。每一个函数的栈都可以储存至多250个寄存器，因为栈的长度是用8个比特表示的。</p>
<p>有了这么多的寄存器，Lua的预编译器能把所有的local变量储存在其中。这就使得Lua在获取local变量时其效率十分的高。</p>
<p>举个栗子： 假设a和b为local变量，<strong><code>a = a + b</code></strong>的预编译会产生一条指令：</p>
<div>
<pre class="prettyprint linenums">;a是寄存器0 b是寄存器1<br />
ADD   </pre>
</div>
<p>但是若a和b都没有声明为local变量，则预编译会产生如下指令：</p>
<div>
<pre class="prettyprint linenums">GETGLOBAL         ;get a<br />
GETGLOBAL         ;get b<br />
ADD              ;do add<br />
SETGLOBAL         ;set a</pre>
</div>
<p>所以你懂的：在写Lua代码时，你应该尽量<strong>使用local变量</strong>。</p>
<p>以下是几个对比测试，你可以复制代码到你的编辑器中，进行测试。</p>
<div>
<pre class="prettyprint linenums">a = os.clock()<br />
for i = , do<br />
  local x = math.sin(i)<br />
end<br />
b = os.clock()<br />
print(b-a) --1.113454</pre>
</div>
<p>把&nbsp;math.sin&nbsp;赋给&nbsp;local&nbsp;变量&nbsp;sin&nbsp;：</p>
<div>
<pre class="prettyprint linenums">a = os.clock()<br />
local sin = math.sin<br />
for i = , do<br />
  local x = sin(i)<br />
end<br />
b = os.clock()<br />
print(b-a) --0.75951</pre>
</div>
<p>直接使用&nbsp;math.sin&nbsp;，耗时<strong>1.11秒</strong>；使用&nbsp;local&nbsp;变量&nbsp;sin&nbsp;来保存<code>math.sin</code>，耗时<strong>0.76秒</strong>。可以获得30%的效率提升！</p>
<h2>关于表(table)</h2>
<p>表在Lua中使用十分频繁，因为表几乎代替了Lua的所有容器。所以快速了解一下Lua底层是如何实现表，对我们编写Lua代码是有好处的。</p>
<p>Lua的表分为两个部分：数组(array)部分和哈希(hash)部分。数组部分包含所有从1到n的整数键，其他的所有键都储存在哈希部分中。</p>
<p>哈希部分其实就是一个哈希表，哈希表本质是一个数组，它利用哈希算法将键转化为数组下标，若下标有冲突(即同一个下标对应了两个不同的键)，则它会将冲突的下标上创建一个<a href="http://wuzhiwei.net/ds_app_linkedlist" rel="external nofollow noreferrer">链表</a>，将不同的键串在这个链表上，这种解决冲突的方法叫做：链地址法。</p>
<p>当我们把一个新键值赋给表时，若数组和哈希表已经满了，则会触发一个再哈希(rehash)。再哈希的代价是高昂的。首先会在内存中分配一个新的长度的数组，然后将所有记录再全部哈希一遍，将原来的记录转移到新数组中。新哈希表的长度是最接近于所有元素数目的2的乘方。</p>
<p>当创建一个空表时，数组和哈希部分的长度都将初始化为0，即不会为它们初始化任何数组。让我们来看下执行下面这段代码时在Lua中发生了什么：</p>
<div>
<pre class="prettyprint linenums">local a = {}<br />
for i=, do<br />
    a[i] = true<br />
end</pre>
</div>
<p>最开始，Lua创建了一个空表a，在第一次迭代中，&nbsp;a[] = true&nbsp;触发了一次rehash，Lua将数组部分的长度设置为&nbsp;^&nbsp;，即1，哈希部分仍为空。在第二次迭代中，&nbsp;a[] = true&nbsp;再次触发了rehash，将数组部分长度设为&nbsp;^&nbsp;，即2。最后一次迭代，又触发了一次rehash，将数组部分长度设为&nbsp;^&nbsp;，即4。</p>
<p>下面这段代码：</p>
<div>
<pre class="prettyprint linenums">a = {}<br />
a.x = ; a.y = ; a.z = </pre>
</div>
<p>与上一段代码类似，只是其触发了三次表中哈希部分的rehash而已。</p>
<p>只有三个元素的表，会执行三次rehash；然而有一百万个元素的表仅仅只会执行20次rehash而已，因为&nbsp;^ =  &gt; &nbsp;。但是，如果你创建了非常多的长度很小的表（比如坐标点：&nbsp;point = {x=,y=}&nbsp;），这可能会造成巨大的影响。</p>
<p>如果你有很多非常多的很小的表需要创建时，你可以将其预先填充以避免rehash。比如：&nbsp;{true,true,true}&nbsp;，Lua知道这个表有三个元素，所以Lua直接创建了三个元素长度的数组。类似的，&nbsp;{x=, y=, z=}&nbsp;，Lua会在其哈希部分中创建长度为4的数组。</p>
<p>以下代码执行时间为1.53秒：</p>
<div>
<pre class="prettyprint linenums">a = os.clock()<br />
for i = , do<br />
    local a = {}<br />
    a[] = ; a[] = ; a[] =<br />
end<br />
b = os.clock()<br />
print(b-a)  --1.528293</pre>
</div>
<p>如果我们在创建表的时候就填充好它的大小，则只需要0.75秒，一倍的效率提升！</p>
<div>
<pre class="prettyprint linenums">a = os.clock()<br />
for i = , do<br />
    local a = {,,}<br />
    a[] = ; a[] = ; a[] =<br />
end<br />
b = os.clock()<br />
print(b-a)  --0.746453</pre>
</div>
<p>所以，<strong>当需要创建非常多的小size的表时，应预先填充好表的大小</strong>。</p>
<h2>关于字符串</h2>
<p>与其他主流脚本语言不同的是，Lua在实现字符串类型有两方面不同。</p>
<p>第一，所有的字符串在Lua中都只储存一份拷贝。当新字符串出现时，Lua检查是否有其相同的拷贝，若没有则创建它，否则，指向这个拷贝。这可以使得字符串比较和表索引变得相当的快，因为比较字符串只需要检查引用是否一致即可；但是这也降低了创建字符串时的效率，因为Lua需要去查找比较一遍。</p>
<p>第二，所有的字符串变量，只保存字符串引用，而不保存它的buffer。这使得字符串的赋值变得十分高效。例如在Perl中，&nbsp;$x = $y&nbsp;，会将&nbsp;$y&nbsp;的buffer整个的复制到&nbsp;$x&nbsp;的buffer中，当字符串很长时，这个操作的代价将十分昂贵。而在Lua，同样的赋值，只复制引用，十分的高效。</p>
<p>但是只保存引用会降低在字符串连接时的速度。在Perl中，&nbsp;$s = $s . 'x'&nbsp;和&nbsp;$s .= 'x'&nbsp;的效率差距惊人。前者，将会获取整个&nbsp;$s&nbsp;的拷贝，并将&nbsp;&rsquo;x&rsquo;&nbsp;添加到它的末尾；而后者，将直接将&nbsp;&rsquo;x&rsquo;&nbsp;插入到&nbsp;$x&nbsp;的buffer末尾。</p>
<p>由于后者不需要进行拷贝，所以其效率和&nbsp;$s&nbsp;的长度无关，因为十分高效。</p>
<p>在Lua中，并不支持第二种更快的操作。以下代码将花费6.65秒：</p>
<div>
<pre class="prettyprint linenums">a = os.clock()<br />
local s = ''<br />
for i = , do<br />
    s = s .. 'a'<br />
end<br />
b = os.clock()<br />
print(b-a)  --6.649481</pre>
</div>
<p>我们可以用table来模拟buffer，下面的代码只需花费0.72秒，9倍多的效率提升：</p>
<div>
<pre class="prettyprint linenums">a = os.clock()<br />
local s = ''<br />
local t = {}<br />
for i = , do<br />
    t[#t + ] = 'a'<br />
end<br />
s = table.concat( t, '')<br />
b = os.clock()<br />
print(b-a)  --0.07178</pre>
</div>
<p>所以：<strong>在大字符串连接中，我们应避免<code>..</code>。应用table来模拟buffer，然后concat得到最终字符串。</strong></p>
<h2>3R原则</h2>
<p>3R原则（the rules of 3R）是：减量化（reducing），再利用（reusing）和再循环（recycling）三种原则的简称。</p>
<p>3R原则本是循环经济和环保的原则，但是其同样适用于Lua。</p>
<h3>Reducing</h3>
<p>有许多办法能够避免创建新对象和节约内存。例如：如果你的程序中使用了太多的表，你可以考虑换一种数据结构来表示。</p>
<p>举个栗子。 假设你的程序中有多边形这个类型，你用一个表来储存多边形的顶点：</p>
<div>
<pre class="prettyprint linenums">polyline = {<br />
    { x = 1.1, y = 2.9 },<br />
    { x = 1.1, y = 3.7 },<br />
    { x = 4.6, y = 5.2 },<br />
    ...<br />
}</pre>
</div>
<p>一百万个顶点时，内存将会由153.3MB减少到107.6MB，但是代价是代码的可读性降低了。</p>
<p>最变态的方法是：</p>
<div>
<pre class="prettyprint linenums">polyline = {<br />
    x = {1.1, 1.1, 4.6, ...},<br />
    y = {2.9, 3.7, 5.2, ...}<br />
}</pre>
</div>
<p>一百万个顶点，内存将只占用32MB，相当于原来的1/5。你需要在性能和代码可读性之间做出取舍。</p>
<p>在循环中，我们更需要注意实例的创建。</p>
<div>
<pre class="prettyprint linenums">for i=,n do<br />
    local t = {,,,'hi'}<br />
    --执行逻辑，但t不更改<br />
    ...<br />
end</pre>
</div>
<p>我们应该把在循环中不变的东西放到循环外来创建：</p>
<div>
<pre class="prettyprint linenums">local t = {,,,'hi'}<br />
for i=,n do<br />
    --执行逻辑，但t不更改<br />
    ...<br />
end</pre>
</div>
<h3>Reusing</h3>
<p>如果无法避免创建新对象，我们需要考虑重用旧对象。</p>
<p>考虑下面这段代码：</p>
<div>
<pre class="prettyprint linenums">local t = {}<br />
for i = ,  do<br />
    t[i] = os.time({year = i, month = , day = })<br />
end</pre>
</div>
<p>在每次循环迭代中，都会创建一个新表<code>{year = i, month = 6, day = 14}</code>，但是只有<code>year</code>是变量。</p>
<p>下面这段代码重用了表：</p>
<div>
<pre class="prettyprint linenums">local t = {}<br />
local aux = {year = nil, month = , day = }<br />
for i = ,  do<br />
    aux.year = i;<br />
    t[i] = os.time(aux)<br />
end</pre>
</div>
<p>另一种方式的重用，则是在于缓存之前计算的内容，以避免后续的重复计算。后续遇到相同的情况时，则可以直接查表取出。这种方式实际就是<a href="http://zh.wikipedia.org/zh/%E5%8A%A8%E6%80%81%E8%A7%84%E5%88%92" rel="external nofollow noreferrer">动态规划</a>效率高的原因所在，其本质是用空间换时间。</p>
<h3>Recycling</h3>
<p>Lua自带垃圾回收器，所以我们一般不需要考虑垃圾回收的问题。</p>
<p>了解Lua的垃圾回收能使得我们编程的自由度更大。</p>
<p>Lua的垃圾回收器是一个增量运行的机制。即回收分成许多小步骤（增量的）来进行。</p>
<p>频繁的垃圾回收可能会降低程序的运行效率。</p>
<p>我们可以通过Lua的&nbsp;collectgarbage&nbsp;函数来控制垃圾回收器。</p>
<p>collectgarbage&nbsp;函数提供了多项功能：停止垃圾回收，重启垃圾回收，强制执行一次回收循环，强制执行一步垃圾回收，获取Lua占用的内存，以及两个影响垃圾回收频率和步幅的参数。</p>
<p>对于批处理的Lua程序来说，停止垃圾回收&nbsp;collectgarbage("stop")&nbsp;会提高效率，因为批处理程序在结束时，内存将全部被释放。</p>
<p>对于垃圾回收器的步幅来说，实际上很难一概而论。更快幅度的垃圾回收会消耗更多CPU，但会释放更多内存，从而也降低了CPU的分页时间。只有小心的试验，我们才知道哪种方式更适合。</p>
<h2>结语</h2>
<p>我们应该在写代码时，按照高标准去写，尽量避免在事后进行优化。</p>
<p>如果真的有性能问题，我们需要用工具量化效率，找到瓶颈，然后针对其优化。当然优化过后需要再次测量，查看是否优化成功。</p>
<p>在优化中，我们会面临很多选择：代码可读性和运行效率，CPU换内存，内存换CPU等等。需要根据实际情况进行不断试验，来找到最终的平衡点。</p>
<p>最后，有两个终极武器：</p>
<p>第一、使用<a href="http://luajit.org/" rel="external nofollow noreferrer">LuaJIT</a>，LuaJIT可以使你在不修改代码的情况下获得平均约5倍的加速。查看LuaJIT在<a href="http://luajit.org/performance_x86.html" rel="external nofollow noreferrer">x86/x64下的性能提升比</a>。</p>
<p>第二、将瓶颈部分用C/C++来写。因为Lua和C的天生近亲关系，使得Lua和C可以混合编程。但是C和Lua之间的通讯会抵消掉一部分C带来的优势。</p>
<p>注意：这两者并不是兼容的，你用C改写的Lua代码越多，LuaJIT所带来的优化幅度就越小。</p>
<h2>声明</h2>
<p>这篇文章是基于Lua语言的创造者Roberto Ierusalimschy在<a href="http://www.lua.org/gems/" rel="external nofollow noreferrer">Lua Programming Gems</a>中的<a href="http://www.lua.org/gems/sample.pdf" rel="external nofollow noreferrer">Lua Performance Tips</a>翻译改写而来。本文没有直译，做了许多删节，可以视为一份笔记。</p>
<p>感谢Roberto在Lua上的辛勤劳动和付出！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pvdnd9.html">【VLC-Android】vlc-android简例</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o234p9.html">Docker&plus;OpenvSwitch搭建VxLAN实验环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/49521369.html">Android中有时候运行程序的时候会报错：An internal error occurred during&colon;。。。。</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wjer3q.html">fedora22多媒体编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjk4549.html">CentOS  FireFox  Flash Player</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojvno1q.html">mysql连接不上Uncaught exception &amp;&num;39&semi;PDOException&amp;&num;39&semi; with message &amp;&num;39&semi;could not find driver</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpx05zq.html">ATL实现ActiveX插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpxrk79.html">记录NPOI使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpmye7q.html">GitHub界面初识</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj0lo69.html">react 的基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5g6y4q.html">SVN添加用户</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r44v68.html">PHP实现 手机号码归属地查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll2nvxq.html">Dapper总结（二）---事务和存储过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy7w339.html">zha男&sol;女的三种境界</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pokv08.html">mysql安装版多次安装导致安装失败的解决方法（windows）（直接使用免安装方法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kjl1oq.html">条件随机场 &lpar;CRF&rpar; 分词序列谈之一&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pppp5d9.html">tomcat 远程命令执行漏洞复现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpgg1e9.html">如何使用linq读取DataTable集合？AsQueryable&lpar;&rpar; 和 AsEnumerable&lpar;&rpar;区别？</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1v3o09.html">Ubuntu 连接手机 不识别设备 -- 解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k3r53q.html">Hadoop网站日志数据清洗&mdash;&mdash;正则表达式实现</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ojdxnpq.html">&lbrack;转&rsqb;HTTPS连接的前几毫秒发生了什么</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdknjz9.html">Python3基础 使用list&lpar;&rpar; 生成一个空列表</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zmzv59.html">bzoj 3879 虚树</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgygo78.html">【poj解题】3664</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jm5038.html">JQuery收集</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj2vlg8.html">&lpar;中等&rpar; CF 311B Cats Transport，斜率优化DP。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljn1g69.html">将Web项目访问的URL项目名设置为&amp;quot&semi;&sol;&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge442l8.html">鸽笼原理的运用HDU1205</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zlnj19.html">LPC1788的IIC使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kplw09.html">LPC2478时钟模块详解</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
